import processing.core.*;
import fullscreen.*;  //um im Vollbildmodus starten zu können.

public class GUI extends PApplet
{
    //RungeKuttaIntegrator ruku = new RungeKuttaIntegrator(new SchwingerModell());
    RungeKuttaIntegrator ruku;
    AutonomesVehikel modell;

    boolean AKTIV = false;
    double x,y,phi,vx,vy,omega,t,dt; //Aktueller Zustand des Fahrzeugs, Meter Meter rad
    
    //Position in Pixeln für die Animation:
    int ix,iy,INDEX=0;
    
    double[] yalt,yneu;
    public void setup()
    {        
        Par.initialisieren(displayWidth,displayHeight);
        
        modell = new AutonomesVehikel();
        ruku = new RungeKuttaIntegrator(modell);
         
        yalt = new double[modell.holeAnzahlGleichungen()];
        yneu = new double[modell.holeAnzahlGleichungen()];
        initialisieren();
        
        size(displayWidth,displayHeight);
        frameRate(10);
        (new FullScreen(this)).enter();                 
    }

    public void zeigeHindernis()
    {
        stroke(0,0,255);
        noFill();
        //Fahrzeugumriß einzeichnen:
        Par.setXYPHI(0.0,0.0,0.0);
        
        float x1 = Par.ktransX(Par.hindernis[0][0],Par.hindernis[0][1]);        
        float y1 = Par.ktransY(Par.hindernis[0][0],Par.hindernis[0][1]);        
        
        float x2 = Par.ktransX(Par.hindernis[1][0],Par.hindernis[1][1]);        
        float y2 = Par.ktransY(Par.hindernis[1][0],Par.hindernis[1][1]);        
        
        float x3 = Par.ktransX(Par.hindernis[2][0],Par.hindernis[2][1]);        
        float y3 = Par.ktransY(Par.hindernis[2][0],Par.hindernis[2][1]);        
        
        float x4 = Par.ktransX(Par.hindernis[3][0],Par.hindernis[3][1]);        
        float y4 = Par.ktransY(Par.hindernis[3][0],Par.hindernis[3][1]);        
        
        line(x1,y1,x2,y2);
        line(x2,y2,x3,y3);
        line(x3,y3,x4,y4);
        line(x4,y4,x1,y1);        
    }

    public void zeigeSensorstrahlAlt(double x, double y, double phi)
    {
        double x1 = x;
        double y1 = y;
        double x2 = x1 + 0.05*Math.cos(phi)-0.05*Math.sin(phi);
        double y2 = y1 + 0.05*Math.sin(phi)+0.05*Math.cos(phi);
        
        double[] schnitt = Par.naechsterSchnittpunkt(x1,y1,x2,y2);
        
        if(schnitt!=null)
        {
            double x3 = schnitt[0];
            double y3 = schnitt[1];
        
//            Par.setXYPHI(0.0,0.0,0.0);
            //Bestimmung der Eckpunkte des umschreibenden Rechtecks
            //in Bildschirmkoordinaten:
            float xx1 = Par.transX(x1);        
            float yy1 = Par.transY(y1);        
        
            float xx3 = Par.transX(x3);        
            float yy3 = Par.transY(y3);                    
            stroke(0,255,0);
            noFill();
            line(xx1,yy1,xx3,yy3);
        }            
    }

    public void zeigeSensorstrahl(double x, double y, double phi)
    {
        modell.aktualisiereSensorwert(x,y,phi);
        
        float xx1 = Par.transX(x);        
        float yy1 = Par.transY(y);        
        
        float xx3 = Par.transX(modell.strahl_x2);        
        float yy3 = Par.transY(modell.strahl_y2);                    
        stroke(0,255,0);
        noFill();
        line(xx1,yy1,xx3,yy3);
    }
    
    public void zeigeFahrzeug(double x, double y, double phi)
    {
        stroke(255,0,0);
        noFill();
        //Fahrzeugumriß einzeichnen:
        Par.setXYPHI(x,y,phi);
        
        //Bestimmung der Eckpunkte des umschreibenden Rechtecks
        //in Bildschirmkoordinaten:
        float x1 = Par.ktransX(0.5*Par.d,Par.q);        
        float y1 = Par.ktransY(0.5*Par.d,Par.q);        
        
        float x2 = Par.ktransX(-0.5*Par.d,Par.q);        
        float y2 = Par.ktransY(-0.5*Par.d,Par.q);        
        
        float x3 = Par.ktransX(-0.5*Par.d,-Par.q);        
        float y3 = Par.ktransY(-0.5*Par.d,-Par.q);        
        
        float x4 = Par.ktransX(0.5*Par.d,-Par.q);        
        float y4 = Par.ktransY(0.5*Par.d,-Par.q);        
        
        line(x1,y1,x2,y2);
        line(x2,y2,x3,y3);
        line(x3,y3,x4,y4);
        line(x4,y4,x1,y1);
    }
    
    public void draw()
    {
        clear();
        
        x=yalt[0];
        y=yalt[1];
        phi=yalt[2];
        vx=yalt[3];
        vy=yalt[4];
        omega=yalt[5];        

        if(modell.kollision(x,y,phi))    
        {
            background(255,255,200);
            
        }
        else
        {
            background(200,200,200);
        }
        
        
        //-----------ANIMATION---------------------
        //Fahrzeugumriß einzeichnen:
        zeigeHindernis();
        zeigeFahrzeug(x,y,phi);
        zeigeSensorstrahl(x,y,phi);
        
        if(modell.rundeVollendet(x,y,phi))
            AKTIV = false;

        //-----------------------------------------

        if(AKTIV)
        {
            for(int i=0;i<10;i++) //zehnfache Menge an Simulationsschritten ausführen, sonst zu grob.
            {
                for(int k=0;k<yalt.length;k++)
                    yalt[k]=yneu[k];
                yneu = ruku.berechneZeitschritt(yalt,t,dt);    
                //yneu[0]=SIM.MATRIX[INDEX][1];
                //yneu[1]=SIM.MATRIX[INDEX][2];
                //yneu[2]=SIM.MATRIX[INDEX][3];
                t+=dt;
                INDEX++;
                INDEX%=SIM.MATRIX.length;
            }
        }
    }

    public void initialisieren()
    {
            INDEX=0;
        
            x=0.0;
            y=-0.3;
            phi=0.0;
            vx=0.0;
            vy=0.0;                        
            omega=0.0;
            t=0.0;
            dt=0.01;
        
            yalt[0]=x;
            yalt[1]=y;
            yalt[2]=phi;
            yalt[3]=vx;
            yalt[4]=vy;
            yalt[5]=omega;
            
            for(int i=0;i<yalt.length;i++)
                yneu[i]=yalt[i];
    }
    
    public void mouseClicked()
    {
        AKTIV=!AKTIV;
        
        if(AKTIV==true)
            initialisieren();
    }

    public static void main(String[] passedArgs) 
    {
        String[] appletArgs = new String[] { "GUI" };
        if(passedArgs != null) 
        {
             PApplet.main(concat(appletArgs, passedArgs));
        } 
        else 
        {
            PApplet.main(appletArgs);
        }            
    }
    
}
