public class Par
{
    public static double SIM_BREITE =2.0;  //sichtbarer Bereich in Metern
    public static double SIM_HOEHE  =2.0;  //sichtbarer Bereich in Metern
    public static double PIXEL_PRO_METER;
    
    public static int PIXEL_BREITE; //Breite des dargestellten Bereichs in Pixeln
    public static int PIXEL_HOEHE;
    public static int PIXEL_XOFF;
    public static int PIXEL_YOFF;

    public static double x,y,phi;

    //Fahrzeugparameter:
    public static double q=0.1;   //Halbe Fahrzeug-Achsbreite
    public static double h=2.0*q; //Fahrzeug-Achsbreite
    public static double d=0.05;  //Fahrzeugtiefe/länge
    
    //Eckpunkte des Hindernisses:
    public static double BREITE_HINDERNIS = 0.8;
    public static double HOEHE_HINDERNIS = 0.3;
    public static double[][] hindernis= {
                                   {-BREITE_HINDERNIS*0.5,-HOEHE_HINDERNIS*0.5},
                                   {BREITE_HINDERNIS*0.5,-HOEHE_HINDERNIS*0.5},
                                   {BREITE_HINDERNIS*0.5,HOEHE_HINDERNIS*0.5},
                                   {-BREITE_HINDERNIS*0.5,HOEHE_HINDERNIS*0.5}
                               };
    
    public static void initialisieren(int BREITE, int HOEHE)//Übergabe der Bildschirmbreite und - höhe
    {
        if((double)BREITE/SIM_BREITE > (double)HOEHE/SIM_HOEHE)
            PIXEL_PRO_METER = (double)HOEHE/SIM_HOEHE;   
        else    
            PIXEL_PRO_METER = (double)BREITE/SIM_BREITE;   
            
        PIXEL_BREITE =  (int)(0.5+PIXEL_PRO_METER*SIM_BREITE);
        PIXEL_HOEHE  =  (int)(0.5+PIXEL_PRO_METER*SIM_HOEHE);
        PIXEL_XOFF   =  (BREITE - PIXEL_BREITE)/2;
        PIXEL_YOFF   =  (HOEHE - PIXEL_HOEHE)/2;
    }
    
    public static float transX(double x) //rechnet Simulationskoordinate x in Pixeln auf dem Bildschirm um.
    {
        //Koordinatenursprung ist in der Mitte:
        x+=SIM_BREITE*0.5;
        return (float)PIXEL_XOFF + (float)(PIXEL_PRO_METER*x);
    }
    
    public static float transY(double y) //rechnet Simulationskoordinate x in Pixeln auf dem Bildschirm um.
    {
        //Koordinatenursprung ist in der Mitte:
        y+=SIM_HOEHE*0.5;
        //y-Koordinatenachse zeigt nach unten beim Bildschirm:       
        y=SIM_HOEHE-y;
        return (float)PIXEL_YOFF + (float)(PIXEL_PRO_METER*y);
    }
    
    /**
     * Liefert x,y verschobene und um phi verdrehte Koordinaten von Körperpunkten xk,yk in Bildschirmkoord.
     *
     */
    public static float ktransX(double x, double y, double phi, double xk, double yk)
    {
        return transX(x + Math.cos(phi)*xk - Math.sin(phi)*yk);
    }
    public static float ktransY(double x, double y, double phi, double xk, double yk)
    {
        return transY(y + Math.sin(phi)*xk - Math.cos(phi)*yk);
    }
    
    public static void setXYPHI(double inx, double iny, double inphi)
    {
        x=inx;
        y=iny;
        phi=inphi;
    }
    public static float ktransX(double xk, double yk)
    {
        return transX(x + Math.cos(phi)*xk - Math.sin(phi)*yk);
    }
    public static float ktransY(double xk, double yk)
    {
        return transY(y + Math.sin(phi)*xk + Math.cos(phi)*yk);
    }

    public static double stransX(double xk, double yk)
    {
        return x + Math.cos(phi)*xk - Math.sin(phi)*yk;
    }
    public static double stransY(double xk, double yk)
    {
        return y + Math.sin(phi)*xk + Math.cos(phi)*yk;
    }
    
    /**
     * x1,y1: Fahrzeugschwerpunkt im Intertialkoordinatensystem
     * x2,y2: Punkt auf "Sensorstrahl" im Inertialkoordinatensystem
     */
    public static double[] naechsterSchnittpunkt(double x1, double y1, double x2, double y2)
    {
        //Schnittpunkte mit allen Geraden, die das Hindernis umschreiben:
        double[][] xy = new double[4][4];

        xy[0] = Hilfsmethoden.schnittpunkt2(x1,y1,x2,y2,
                  hindernis[0][0],hindernis[0][1],hindernis[1][0],hindernis[1][1]);
        xy[1] = Hilfsmethoden.schnittpunkt2(x1,y1,x2,y2,
                  hindernis[1][0],hindernis[1][1],hindernis[2][0],hindernis[2][1]);
        xy[2] = Hilfsmethoden.schnittpunkt2(x1,y1,x2,y2,
                  hindernis[2][0],hindernis[2][1],hindernis[3][0],hindernis[3][1]);
        xy[3] = Hilfsmethoden.schnittpunkt2(x1,y1,x2,y2,
                  hindernis[3][0],hindernis[3][1],hindernis[0][0],hindernis[0][1]);
/*                  
for(int i=0;i<4;i++)
{
    if(xy[i]!=null)
    {
        System.out.println("**** xy"+i+"="+xy[i][0]+","+xy[i][1]);
    }
}
*/
        //x1,y1+a*rsensor, a muss positiv sein:
//        boolean[] ok = {true,true,true,true};
        boolean[] ok = {true,false,false,false};
        for(int i=0;i<xy.length;i++)
            if(xy[i]==null)
                ok[i]=false;
        for(int i=0;i<xy.length;i++)
            if(xy[i]!=null && xy[i][2]<=0)//Faktor a der ersten Geraden (Sensor) negativ
                ok[i]=false;
                
        if(ok[0]==false && ok[1]==false && ok[2]==false && ok[3]==false)                
            return null;
        
        for(int k=0;k<ok.length;k++)
             for(int p=0;p<ok.length;p++)
                 if(ok[k]==true && ok[p]==true && xy[k]!=null && xy[p]!=null && xy[k][2]>xy[p][2])
                     ok[k]=false;
        for(int k=0;k<ok.length;k++)
            if(ok[k]==true)
                return new double[] {xy[k][0],xy[k][1]};
        return null;        
    }
    
    public static void main(String[] args)
    {
        double[] s1 = naechsterSchnittpunkt(0.0,-0.2, 0.0+0.05, -0.2-0.05);
        System.out.println(s1[0]+" "+s1[1]);
    }
}
